/******************************************************************
 *	traVA for `sQRPR
 ******************************************************************
 *	
 *	
 *	R}hs:
static	void cmdTxRx(RxBuf *q);
static	void cmdPeek(RxBuf *q);
static	void cmdPoke(RxBuf *q);
 *
 *	trax_[NGXg̏:
uchar	usbFunctionSetup(uchar data[8]);
 *
 *	ƃC:
static	void hardwareInit(void);
int		main(void);
 *
 */


/******************************************************************
 *	include
 ******************************************************************
 */

#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>

#include "usbdrv/usbdrv.h"
#include "usbdrv/oddebug.h"

#define	MAX_RXPACKET	24

#include "usart.h"


/******************************************************************
 *	Device / Config Descriptor
 ******************************************************************
 */
uchar usbFunctionDescriptor(usbRequest_t *rq);
#include "usbdesc.h"

//
//	Rg[]Ŏ󂯎R}hpPbg.
//
typedef	struct {
	uchar bmRequestType;
	uchar cmd;
	uchar *adr;
	uchar data0;
	uchar data1;
	int   wLength;
} RxBuf;

//
//	cmd = [ 0 aa ccccc ]   a = area , c = cmd
//
enum {
	CMD_NOP  ,
	CMD_01	 ,
	CMD_02	 ,
	CMD_03	 ,
	CMD_04	 ,
	CMD_PEEK ,
	CMD_POKE ,
	CMD_BAUD ,
	CMD_MASK = 0x1f,
};


//
//	[ǂݏ̃IvV.
//
enum {
	AREA_RAM    = 0   ,
	AREA_EEPROM = 0x20,
	AREA_PGMEM  = 0x40,
	AREA_MASK	= 0x60,
};


static uchar result[MAX_RXPACKET];	//Rg[]R}h̏ʃobt@(hostԑp)

void pgmemcpy(uchar *t,int adr,uchar size);

/******************************************************************
 *	qrQRQbf[^̎.
 ******************************************************************
    0      1      2      3      4      5      6      7
 +------+------+---------------------------+-------------+
 | req  | cmd  | Mf[^iőSoCgj|   wlength   |
 +------+------+---------------------------+-------------+
Mf[^͓sEl߂ĂB
cmd ͗LȑM
0   ̂Ƃ͑Mf[^Ȃ

 * MpPbg
    0      1      2      3      4      5      6      7
 +------+------------------------------------------------+
 | size |     Mf[^iőVoCgj                 |
 +------+------------------------------------------------+
size͂O`V
sizêlraPɂȂƂ͑MۂꂽB(TxBuf FULL)
̏ꍇob͓f[^đB
 */
static int cmdTxRx(RxBuf *q)
{
	uchar *p  = (uchar *)q;	//GCAXptr.
	uchar cnt = q->cmd;		//.
	uchar txack;

	if(	rsptr < TXBUF_SIZE) {	//Mobt@Ƀf[^cĂȂ,
		//󂯎f[^j.
		//đv.
		txack = 0x80;
	}else{
		//
		//Mobt@Ƀf[^Zbg.
		//
		memcpy(rsbuf , p+2 ,4);	//ӁFLӂȃf[^͌l߂Ă邱.
		rsptr = (4-cnt);		//obt@ǂݏo|C^͗Lӂȃf[^̐擪w.
		txack = 0;
	}
	//
	//Mobt@ԋp.
	//
	return USART_RecvData(result,txack);
}

/******************************************************************
 *	[ǂݏo.
 ******************************************************************
    0      1      2      3      4      5      6      7
 +------+------+-------------+------+------+-------------+
 | req  | cmd  |     adr     | len  |      |   wlength   |
 +------+------+-------------+------+------+-------------+
len͂O`W
UgpPbgiWoCgjŃf[^Ԃ.
 */
static void cmdPeek(RxBuf *q)
{
	uchar sub = q->cmd & AREA_MASK;
	if(sub == AREA_RAM) {
		memcpy(result,q->adr,q->data0);
	}else
	if(sub == AREA_PGMEM) {
		pgmemcpy(result,(int)q->adr,q->data0);
	}
}

/******************************************************************
 *	[.
 ******************************************************************
    0      1      2      3      4      5      6      7
 +------+------+-------------+------+------+-------------+
 | req  | cmd  |     adr     |data0 |data1 |   wlength   |
 +------+------+-------------+------+------+-------------+
data1[̂Ƃ́A}XNp^[Iȏŏ.

UgpPbg͕svA_~[łWoCgԂ.
 */
static void cmdPoke(RxBuf *q)
{
	uchar *p = (uchar *)q->adr;
	if(q->data1) {	//}XNt̏.
		*p = (*p & q->data1) | q->data0;
	}else{			//ׂ.
		*p = q->data0;
	}
}

/******************************************************************
 *	ftHgȊÕRg[]ɌĂяoGg[.
 ******************************************************************
 *	x_NGXg̓NXNGXgɉ.
 *	   :usbRequset_t *rq;      NGXgpPbg\.
 *          ڍׂ usbdrv.h Q.
 *			rq->bRequest ɃR}hԍ邱Ƃ.
 *	߂l :uchar         replyLen 
 *			oCgԂꍇ usbMsgPtrɃAhXĂ.
 *			0xff Ԃꍇ usbFunctionRead()Ăяo.
 *
 */
uchar usbFunctionSetup(uchar data[8])
{
    usbMsgPtr = result;

	RxBuf *q = (RxBuf *)data;
	uchar cmd = q->cmd & CMD_MASK;	//R}h.

	if(cmd <= CMD_04) {
		return cmdTxRx(q);			// qrQRQbf[^̑pPbg.
	}
	if(cmd == CMD_PEEK) {
		cmdPeek(q);			// [ǂݏo.
		return 8;
	}
	if(cmd == CMD_POKE) {
		cmdPoke(q);			// [.
		return 8;
	}
	if(cmd == CMD_BAUD) {
		cmdBaud(data[2],data[3],data[4]);	// {[[gݒ.
		return 8;
	}
	return 8;
}

/******************************************************************
 *	|[g̏
 ******************************************************************
 */
static void hardwareInit(void)
{
	// c{Ac| PORT rbg 0 ɂ.
	USB_CFG_IOPORT = ~((1<<USB_CFG_DMINUS_BIT)|(1<<USB_CFG_DPLUS_BIT));
	/* USB_CFG_IOPORT  PORTD Ɠ : ܂ PORTD = 0xf3 Ɠ */

	// PORTBׂē̓[hɂPull-UP.
	DDRB  = 0;
	PORTB = 0xff;

// D݂ɍ킹Đ؂ւĂ.
#if	1
	// c{Ac|́A͏o̓[hɃZbgB
	USBDDR    = ~((1<<USB_CFG_DMINUS_BIT)|(1<<USB_CFG_DPLUS_BIT));
	/* USBDDR  DDRD Ɠ : ܂ DDRD = 0xf3 Ɠ */
#else
	// c{Ac|܂߁APORTDׂē̓[hɂB
	USBDDR    = 0;
	// c{Ac|ȊOPULL-UP.
	PORTD     = 0xf3;

#endif

}


/******************************************************************
 *	C
 ******************************************************************
 */
int main(void)
{
	hardwareInit();
	USART_Init(USART_default_baud);
	usbInit();

	sei();
	for(;;){
		usbPoll();
		USART_RecvTask();
		USART_SendTask();
	}
}

